"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseArgsString = parseArgsString;
/**
 * Parse a string arguments to a plain object.
 *
 * @param argsString The string arguments.
 * @returns The parsed plain object.
 *
 * @category Utils
 */
function parseArgsString(argsString) {
    var _a = __read(splitArgsString(formatArgsString(argsString)), 2), positional = _a[0], optional = _a[1];
    return [positional, Object.fromEntries(parseArgsArray(optional))];
}
/**
 * Parse an array of string arguments to an array of tuples.
 *
 * @param args The array of string arguments.
 * @returns The parsed array of tuples.
 *
 * @category Utils
 */
function parseArgsArray(args) {
    return args
        .map(function (x) { return x.split(/ (.+)/).slice(0, 2); })
        .map(function (x) { return x.length === 1 ? [x[0], ''] : x; })
        .filter(function (x) { return x[0] !== ''; });
}
/**
 * Split an arguments string to an array of strings.
 *
 * @param argsString The string arguments.
 * @returns The split array of strings.
 *
 * @category Utils
 */
function splitArgsString(argsString) {
    var e_1, _a;
    var exploded = argsString.split(' -').map(function (x, i) { return i === 0 ? x : "-".concat(x); });
    var positional = [];
    var optional = [];
    var positionalFinished = false;
    try {
        for (var exploded_1 = __values(exploded), exploded_1_1 = exploded_1.next(); !exploded_1_1.done; exploded_1_1 = exploded_1.next()) {
            var x = exploded_1_1.value;
            if (x.startsWith('-')) {
                positionalFinished = true;
            }
            if (positionalFinished) {
                optional.push(x);
            }
            else {
                positional.push.apply(positional, __spreadArray([], __read(x.split(' ').filter(function (x) { return x !== ''; })), false));
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (exploded_1_1 && !exploded_1_1.done && (_a = exploded_1.return)) _a.call(exploded_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return [positional, optional];
}
/**
 * Format an arguments string.
 *
 * @param argsString The string arguments.
 * @returns The formatted string.
 *
 * @category Utils
 */
function formatArgsString(argsString) {
    return argsString
        .trim()
        .replace(/\s+/g, ' ')
        .replace(/^(-[A-Za-z0-9]{2,})/, function (_, p) { return ' ' + formatGluedArgsString(p); })
        .replace(/ (-[A-Za-z0-9]{2,})/, function (_, p) { return ' ' + formatGluedArgsString(p); })
        .replace(/\s+/g, ' ')
        .trim();
}
/**
 * Format a glued arguments string.
 *
 * @param gluedArgsString The glued arguments string.
 * @returns The formatted string.
 *
 * @category Utils
 */
function formatGluedArgsString(gluedArgsString) {
    return gluedArgsString.slice(1).split('').map(function (x) { return "-".concat(x); }).join(' ');
}
//# sourceMappingURL=parse.js.map